org.apache.storm.opentsdb.bolt

## Class OpenTsdbBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.opentsdb.bolt.OpenTsdbBolt

- All Implemented Interfaces:
    Serializable, IBolt, IComponent, IRichBolt

      public class OpenTsdbBolt
      extends BaseRichBolt

  Basic bolt implementation for storing timeseries datapoints to OpenTSDB.

  List of `OpenTsdbMetricDatapoint` is generated for each tuple with the configured `tupleOpenTsdbDatapointMappers`. All these datapoints are batched till the given `batchSize` or `flushIntervalInSeconds` is reached.

  Example topology:

  >      OpenTsdbClient.Builder builder = OpenTsdbClient.newBuilder(openTsdbUrl).sync(30_000).returnDetails(); final OpenTsdbBolt openTsdbBolt = new OpenTsdbBolt(builder, Collections.singletonList(TupleOpenTsdbDatapointMapper.DEFAULT_MAPPER)); openTsdbBolt.withBatchSize(10).withFlushInterval(2).failTupleForFailedMetrics(); topologyBuilder.setBolt(“opentsdb”, openTsdbBolt).shuffleGrouping(“metric-gen”);

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `OpenTsdbBolt(OpenTsdbClient.Builder openTsdbClientBuilder, ITupleOpenTsdbDatapointMapper tupleOpenTsdbDatapointMapper)`
    `OpenTsdbBolt(OpenTsdbClient.Builder openTsdbClientBuilder, List<? extends ITupleOpenTsdbDatapointMapper> tupleOpenTsdbDatapointMappers)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanup()` Called when an IBolt is going to be shutdown.
    `void` | `declareOutputFields(OutputFieldsDeclarer declarer)` Declare the output schema for all the streams of this topology.
    `void` | `execute(Tuple tuple)` Process a single tuple of input.
    `OpenTsdbBolt` | `failTupleForFailedMetrics()` When it is invoked, this bolt acks only the tuples which have successful metrics stored into OpenTSDB and fails the respective tuples of the failed metrics.
    `Map<String,Object>` | `getComponentConfiguration()` Declare configuration specific to this component.
    `void` | `prepare(Map<String,Object> topoConf, TopologyContext context, OutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.
    `OpenTsdbBolt` | `withBatchSize(int batchSize)`
    `OpenTsdbBolt` | `withFlushInterval(int flushIntervalInSeconds)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OpenTsdbBolt

          public OpenTsdbBolt(OpenTsdbClient.Builder openTsdbClientBuilder,
                              ITupleOpenTsdbDatapointMapper tupleOpenTsdbDatapointMapper)

    - #### OpenTsdbBolt

          public OpenTsdbBolt(OpenTsdbClient.Builder openTsdbClientBuilder,
                              List<? extends ITupleOpenTsdbDatapointMapper> tupleOpenTsdbDatapointMappers)

  - ### Method Detail

    - #### withFlushInterval

          public OpenTsdbBolt withFlushInterval(int flushIntervalInSeconds)

    - #### withBatchSize

          public OpenTsdbBolt withBatchSize(int batchSize)

    - #### failTupleForFailedMetrics

          public OpenTsdbBolt failTupleForFailedMetrics()

      When it is invoked, this bolt acks only the tuples which have successful metrics stored into OpenTSDB and fails the respective tuples of the failed metrics.

      Returns:
        same instance by setting `failTupleForFailedMetrics` to true

    - #### prepare

          public void prepare(Map<String,Object> topoConf,
                              TopologyContext context,
                              OutputCollector collector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### execute

          public void execute(Tuple tuple)

      Description copied from interface: `IBolt`

      Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

      Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

      For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

      Parameters:
        `tuple` - The input tuple to be processed.

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`

      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`
      Overrides:
        `cleanup` in class `BaseRichBolt`

    - #### declareOutputFields

          public void declareOutputFields(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`

      Declare the output schema for all the streams of this topology.

      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### getComponentConfiguration

          public Map<String,Object> getComponentConfiguration()

      Description copied from interface: `IComponent`

      Declare configuration specific to this component. Only a subset of the “topology.*” configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`

      Specified by:
        `getComponentConfiguration` in interface `IComponent`
      Overrides:
        `getComponentConfiguration` in class `BaseComponent`

Copyright © 2021 The Apache Software Foundation. All rights reserved.